
%%clear up any old variables/objects

close all;
clear;
imtool close all; 
clc;
imaqreset;

% info = imaqhwinfo('winvideo');
% info.DeviceInfo.SupportedFormats;

a = arduino('COM9');

%Pin IO Methods: pinMode digitalRead digitalWrite analogRead analogWrite
 
%set up IO pins
% 
%drive left
a.pinMode(4,'input');
a.pinMode(7,'output');
a.digitalWrite(7,0);
%drive right
a.pinMode(8,'input');
a.pinMode(12,'output');
a.digitalWrite(12,0);
%run stop switch
a.pinMode(2,'input');

%initialize video
vid = videoinput('winvideo',1, 'RGB24_640x480');
vidRES = get(vid,'VideoResolution');
nBands = get(vid, 'NumberOfBands');
hImage = image(zeros(vidRES(2), vidRES(1), nBands));

figure(1);
hold on;
preview(vid,hImage);

%initialize variables
tcurrent = clock;
tlastimage = tcurrent;
tlastgoal = tcurrent;
tlastsample = tcurrent;
tstart = tcurrent;
RUN = 1;
Left = 0;
Right = 0;
goalon = 0;
n = 0;
samplecount = 0;
Llaststate = 0;
Rlaststate = 0;

while RUN == 1;  
    
%-----------------------------------------------
%%events
    
    image = getsnapshot(vid);
    

    
    %check time variables
    tcurrent = clock;
    
    %time since start of game
    deltTgame = tcurrent(6) - tstart(6); 
    if deltTgame < 0;
        deltTgame = deltTgame + 60;
    end;
    
    %time since last goal display
    deltTG = tcurrent(6) - tlastgoal(6); 
    if deltTG < 0;
        deltTG = deltTG + 60;
    end;
    
    %time since last sample
    deltTS = tcurrent(6) - tlastsample(6); 
    if deltTS < 0;
        deltTS = deltTG + 60;
    end;
    
    %check arduino inputs
    if deltTS > 0.1;
        
        %check RUN switch
        RUN = a.digitalRead(2);
    
        %check Left switch
        Left = a.digitalRead(4);
    
        %check Right switch
        Right = a.digitalRead(8);  
    end
    
%-----------------------------------------------------------
%%services

    %end game after 30 seconds
%     if deltTgame > 30;
%         RUN = 0;
%     end
    
    %steer paramecium
    if Left > 0 && Llaststate <1;
        a.digitalWrite(7,1);
        Llaststate = 1
    elseif Left < 1 && Llaststate > 0;
        a.digitalWrite(7,0);
        Llaststate = 0
    else
    end
    
    if Right >0 && Rlaststate <1;
        a.digitalWrite(12,1);
        Rlaststate = 1
    elseif Right <1 && Rlaststate > 0;
        a.digitalWrite(12,0);
        Rlaststate = 0
    else
    end
    
    %toggle goal draw 
    if deltTG > 5;
        tlastgoal = tcurrent; %reset time for goal display
        
        if goalon==0;    
            goal = rectangle('Position',[220,4,200,472],'LineWidth',2,'EdgeColor',[255/255,0/255,0/255]);
            goalon =1;
        elseif goalon ==1;
            delete(goal);   
            goalon = 0;
        else 
        end     
    end;
        
    %sample image area for paramecium
    if deltTS > 0.1;
        tlastsample = tcurrent; %reset time for sample

        if goalon ==1;  
            image = image(220:419,4:475,:);%sample the goal area
            goalcurrent = mean(image,3); %convert to gray from RGB
            %goalcurrent =image(:,:,2); %convert to gray from green LED
            
            if samplecount == 0;
                goallast = goalcurrent; 
                samplecount = 1;
            
            else            
                imageDiff = abs(goalcurrent - goallast);
                [rows,cols,vals] = find(imageDiff>50);
                diffpixels(samplecount) = length(vals);
                goallast = goalcurrent;
                samplecount = samplecount + 1;
            end
           
        else
            
        end   
    end
end;

%nice to see on screen if out of while loop
finished = 1

figure(2);
plot(diffpixels);

score = sum(diffpixels)

a.delete;
stop(vid);
delete(vid);
clear vid;





